package precondicions;

import objectes.pila;
import operacions.Operador;

public class Precondicio {
	private String nom;
	private char X,Y;
	private char libre;
	
	public Precondicio(String nom, char x, char y,char lliure) {
		super();
		this.nom = nom;
		X = x;
		Y = y;
		libre=lliure;
	}

	public String getNom() {
		return nom;
	}

	//Metode que ens torna true si la precondicio esta instanciada
	//i false si esta parcialment instanciada
	public boolean instanciado(){
		if ((nom.equals("sobretaula")) && (X!=' ')){
			return true;
		}
		if ((nom.equals("sobre"))&& (X!=' ') && (Y!=' ')){
			return true;
		}
		if ((nom.equals("lliure")) && (X!=' ')) {
			return true;
		}
		if (nom.equals("brazolibre")){
			return true;
		}
		if ((nom.equals("cogido"))&& (X!=' ')){
			return true;
		}
		return false;
	}
	
	//Funcio que ens retorna una operacio, aplica heuristica.
	public Operador buscaroperador(pila estado, int ncols,pila ef){
		if (nom.equals("sobretaula")){
			return (new Operador("dejar",X,' '));
		}
		if (nom.equals("sobre")){
			return (new Operador("apilar",X,Y));
		}
		if (nom.equals("lliure")){
			return (new Operador("desapilar",Y,X));
		}
		if (nom.equals("cogido")){
			return (new Operador("coger",X,' '));
		}
		if (nom.equals("brazolibre")){
			if (ncols<3) {
			//busquem que tenim agafat!!! per deixar-ho
			char O=estado.agafat(estado);
			return (new Operador("dejar",O,' '));
			}else{
			//mirem que tenim agafat
			char O=estado.agafat(estado);
			//busquem a l'estat final sobre que te que anar el bloc
			char S=ef.sota(O);
			return (new Operador("apilar",O,S));	
			}
		}
		return null;
	}


	public char getX() {
		return X;
	}

	public char getY() {
		return Y;
	}

	
	//Apliquem heuristica per veure per quina variable la instanciem
	//i despres substituim per la variable escollida
	public void aplicar_heuristica(pila estat,pila ef,pila p) {
		if ((nom.equals("sobretaula")) && (X==' ')){
			if (ef.secumple(new Precondicio("sobretaula",'A',' ',' '))){
				X='A';
			}
			if (ef.secumple(new Precondicio("sobretaula",'B',' ',' '))){
				X='B';
			}
			if (ef.secumple(new Precondicio("sobretaula",'C',' ',' '))){
				X='C';
			}
			if (ef.secumple(new Precondicio("sobretaula",'D',' ',' '))){
				X='D';
			}
		}
		
		
		if ((nom.equals("sobre")) && (X==' ')){
			//En aquest cas hem de instanciar buscant que es el que esta sobre
			// de la variable Y, per tant busquem al estat actual que hi ha
			//sobre la variable Y
			char z=estat.damunt(Y);
			//un cop tenim l'instanciacio instanciem fins el primer operador
			p.instanciarfinsop(z);
			X=z;
		}
		
		//quan es lliure mirem si el seguent de la pila es un desapilar(x,BLOC)
		//en el cas de que sigui sobre, mirem que hi ha sobre el bloc al estat
		//actual
		if ((nom.equals("lliure")) && (X==' ')) {
			Object i,k;
			i=p.primer();
			while (!(i instanceof Operador)){
			i=p.primer();	
			}
			if (((Operador)i).getNom().equals("desapilar")){
				//busquem a l'estat actual que hi ha sobre de Y, per a poderlo desapilar
				char instancia=estat.buscarquehihasobre((Operador)i);
				((Operador)i).setX(instancia);
			}
		}
		
		
		if (nom.equals("brazolibre")){
			
			//return true;
		}
		
		if ((nom.equals("cogido"))&& (X==' ')){
			
			//return true;
		}
		
	}

	public void setX(char x) {
		X = x;
	}
	
}
